import { Closeable, Deferred, Demultiplexer, Deserializer, DuplexConnection, Frame, FrameHandler, Multiplexer, Outbound } from "rsocket-core";
export declare class WebsocketDuplexConnection extends Deferred implements DuplexConnection, Outbound {
    private websocket;
    private deserializer;
    readonly multiplexerDemultiplexer: Multiplexer & Demultiplexer & FrameHandler;
    constructor(websocket: WebSocket, deserializer: Deserializer, multiplexerDemultiplexerFactory: (outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler);
    get availability(): number;
    close(error?: Error): void;
    send(frame: Frame): void;
    private handleClosed;
    private handleError;
    private handleMessage;
}
